//! @file power_drv.h,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͓d͊Ǘײޒ`܂݂܂B
//! ̕AVR̊ed͓`Ԃ̌`ԐݒƓۯOu̍\ݒ
//! ܂B
//!
//! @version 1.5 at90usb128-demo-mouse-1_0_3 $Id: power_drv.h,v 1.5 2006/03/10 15:21:22 rletendu Exp $
//!
//! @todo
//! @bug

#ifndef _POWER_DRV_H_
#define _POWER_DRV_H_

//! @defgroup powermode d͊Ǘײޕ
//!
//! @{

//_____ ϸ ________________________________________________________________

#define Setup_idle_mode()					(SMCR=0,SMCR |= (1<<SE))
#define Setup_power_down_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM1))
#define Setup_adc_noise_reduction_mode()	(SMCR=0,SMCR |= (1<<SE)+(1<<SM0))
#define Setup_power_save_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM1)+(1<<SM0))
#define Setup_standby_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM2)+(1<<SM1))
#define Setup_ext_standby_mode()			(SMCR=0,SMCR |= (1<<SE)+(1<<SM2)+(1<<SM1)+(1<<SM0))

//! Clear_prescaler
//!
//! ̊֐͓CPU ۯOuؾĂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Clear_prescaler()					(CLKPR = (1<<CLKPCE),CLKPR = 0)

//! Set_prescaler
//!
//! ̊֐͓CU ۯOul`Ԑݒ肵܂B
//!
//! @param x: VOul
//!
//! @return	Ȃ
//!
#define Set_prescaler(x)					(CLKPR = (1<<CKLPCE),CLKPR = x)

#define Sleep_instruction()					{asm("SLEEP");}

// ߋ݊
#define Set_power_down_mode()				set_power_down_mode()
#define Set_idle_mode()						set_idle_mode()

//_____ 錾 _______________________________________________________________

void set_idle_mode(void);
void set_power_down_mode(void);
void set_adc_noise_reduction_mode(void);
void set_power_save_mode(void);
void set_standby_mode(void);
void set_ext_standby_mode(void);

//! Enter_idle_mode
//!
//! ̊֐AVRٓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_idle_mode()					(set_idle_mode())

//! Enter_power_down_mode
//!
//! ̊֐AVRܰ޳ݓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_power_down_mode()				(set_power_down_mode())

//! Enter_adc_noise_reduction_mode
//!
//! ̊֐AVRA/DϊGጸɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_adc_noise_reduction_mode()	(set_adc_noise_reduction_mode())

//! Enter_power_save_mode
//!
//! ̊֐AVRܰޓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_power_save_mode()				(set_power_save_mode())

//! Enter_standby_mode
//!
//! ̊֐AVR޲Ɉڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_standby_mode()				(set_standby_mode())

//! Enter_ext_standby_mode
//!
//! ̊֐AVRg޲Ɉڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_ext_standby_mode()			(set_ext_standby_mode())

//! @}

#endif // _POWER_DRV_H_
