//! @file usb_descriptors.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBҰ
//!
//! ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! @version 1.6 at90usb128-demo-mouse-1_0_3 $Id: usb_descriptors.c,v 1.6 2006/08/01 14:19:28 rletendu Exp $
//!
//! @todo
//! @bug


//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "modules\usb\device_chap9\usb_standard_request.h"
#include "usb_specific_request.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DEVICE_DESCRIPTOR,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{ sizeof(S_usb_configuration_descriptor),
	CONFIGURATION_DESCRIPTOR,
	Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)\
							 +sizeof(S_usb_interface_descriptor)    \
							 +sizeof(S_usb_hid_descriptor)          \
							 +sizeof(S_usb_endpoint_descriptor)),   \
	NB_INTERFACE,
	CONF_NB,
	CONF_INDEX,
	CONF_ATTRIBUTES,
	MAX_POWER
	},
	{ sizeof(S_usb_interface_descriptor),
	INTERFACE_DESCRIPTOR,
	INTERFACE_NB_MOUSE,
	ALTERNATE_MOUSE,
	NB_ENDPOINT_MOUSE,
	INTERFACE_CLASS_MOUSE,
	INTERFACE_SUB_CLASS_MOUSE,
	INTERFACE_PROTOCOL_MOUSE,
	INTERFACE_INDEX_MOUSE
	},
	{ sizeof(S_usb_hid_descriptor),
	HID_DESCRIPTOR,
	HID_BDC,
	HID_COUNTRY_CODE,
	HID_CLASS_DESC_NB,
	HID_DESCRIPTOR_TYPE,
	Usb_write_word_enum_struc(sizeof(S_usb_hid_report_descriptor_mouse))
	},
	{ sizeof(S_usb_endpoint_descriptor),
	ENDPOINT_DESCRIPTOR,
	ENDPOINT_NB_1,
	EP_ATTRIBUTES_1,
	Usb_write_word_enum_struc(EP_SIZE_1),
	EP_INTERVAL_1
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	STRING_DESCRIPTOR,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	STRING_DESCRIPTOR,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
code S_usb_serial_number usb_user_serial_number =
{
	sizeof(usb_user_serial_number),
	STRING_DESCRIPTOR,
	USB_SERIAL_NUMBER
};

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	STRING_DESCRIPTOR,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};

code S_usb_hid_report_descriptor_mouse usb_hid_report_descriptor_mouse =
{{
		0x05,0x01,			/* p@ ߰ (W޽į)     */
		0x09,0x02,			/* p@ (ϳ)                    */
		0xA1,0x01,			/* W (p)                   */
		0x09,0x01,			/* p@ (߲)                  */
		0xA1,0x00,			/* W (p)                   */
		0x05,0x09,			/* p@ ߰ (t)               */
		0x19,0x01,			/* p@ ŏ (1)                 */
		0x29,0x03,			/* p@ ő (3)                 */
		0x15,0x00,			/* _ ŏ (0)                 */
		0x25,0x01,			/* _ ő (1)                 */
		0x75,0x01,			/*  傫 (1)               */
		0x95,0x03,			/*   (3)                 */
		0x81,0x02,			/*  (ްAϗʁA)       */
		0x75,0x05,			/*  傫 (5)               */
		0x95,0x01,			/*   (1)                 */
		0x81,0x01,			/*  (萔)                   */
		0x05,0x01,			/* p@ ߰ (W޽įߐ) */
		0x09,0x30,			/* p@ X                        */
		0x09,0x31,			/* p@ Y                        */
		0x09,0x38,			/* p@                        */
		0x15,0x81,			/* _ ŏ (-127)              */
		0x25,0x7F,			/* _ ő (127)               */
		0x75,0x08,			/*  傫 (8)               */
		0x95,0x03,			/*   (3)                 */
		0x81,0x06,			/*  (ްAϗʁA)       */
		0xC0,				/* I W                     */
		0xC0				/* I W                     */
}};
