//! @file pll_drv.h
//! pll_drv.h,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قUSB PLLp̒ϸۂƒ`܂݂܂B
//!
//! @version 1.7 at90usb128-demo-mouse-1_0_3
//!
//! @todo

#ifndef PLL_DRV_H
#define PLL_DRV_H

//_____ ݸٰ ____________________________________________________________

//! @defgroup PLL PLLײޕ
//! PLL
//! @{

//_____ ϸ ________________________________________________________________

	//! @defgroup PLL_macros PLLϸ
	//! ̊֐PLL̐܂B
	//! @{
#define PLLx24			( (0<<PLLP2) | (0<<PLLP1) | (0<<PLLP0) )
#define PLLx12			( (0<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define PLLx08			( (0<<PLLP2) | (1<<PLLP1) | (0<<PLLP0) )
#define PLLx06			( (0<<PLLP2) | (1<<PLLP1) | (1<<PLLP0) )
#define PLLx04			( (1<<PLLP2) | (0<<PLLP1) | (0<<PLLP0) )
#define PLLx03			( (1<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define PLLx04_8		( (1<<PLLP2) | (1<<PLLP1) | (0<<PLLP0) )
#define PLLx02			( (1<<PLLP2) | (1<<PLLP1) | (1<<PLLP0) )

		//! @brief CPUgɊ֌W48MHzłPLLJn
		//! ۯWUSB PLLJn
		//! ۯWPLL~24,PLL~12,PLL~8,PLL~6,PLL~4,PLL~3ɂł܂B
#define Start_pll(clockfactor)	(PLLCSR = ( clockfactor  | (1<<PLLE)  ))
		//! PLLŒ艻1ԂB
#define Is_pll_ready()			(PLLCSR & (1<<PLOCK) )
		//! PLLŒ艻ޯČƌŒ艻ޯĐݒ܂őҋ@
#define Wait_pll_ready()		while (!(PLLCSR & (1<<PLOCK)))
		//! PLL~
#define Stop_pll()				(PLLCSR  &= (~(1<<PLLE)) ) 

		// FOSC`ɊւĎW`ԂPLLJn
#if   (FOSC==2000)
	#define Pll_start_auto()	Start_pll(PLLx24)
#elif (FOSC==4000)
	#define Pll_start_auto()	Start_pll(PLLx12)
#elif (FOSC==6000)
	#define Pll_start_auto()	Start_pll(PLLx08)
#elif (FOSC==8000)
	#define Pll_start_auto()	Start_pll(PLLx06)
#elif (FOSC==12000)
	#define Pll_start_auto()	Start_pll(PLLx04)
#elif (FOSC==16000)
	#define Pll_start_auto()	Start_pll(PLLx03)
#elif (FOSC==20000)
	#define Pll_start_auto()	Start_pll(PLLx04_8)
#elif (FOSC==24000)
	#define Pll_start_auto()	Start_pll(PLLx02)
#else
	#error "FOSC should be defined in config.h"
#endif

	//! @}

//! @}
#endif // PLL_DRV_H
