/**
 * @file usb_task.h,v
 *
 * 쌠 (c) 2006 Atmel.
 *
 * 쌠ʒmɂĂlicense.txţقǂ݂B
 *
 * @brief ̧ق͊֐錾܂݂܂B
 *
 * @version 1.11 at90usb128-demo-mouse-1_0_3 $Id: usb_task.h,v 1.11 2006/06/16 07:05:43 rletendu Exp $
 *
 * @todo
 * @bug
 */

#ifndef _USB_TASK_H_
#define _USB_TASK_H_

//! @defgroup usb_task USBƓ_
//! @{

//_____ ݸٰ ____________________________________________________________

//_____ ϸ ________________________________________________________________

	//! @defgroup usb_software_evts USBĳۊǗ
	//! 荞݉ŌoꂽUSBۂǗϸ
	//! @{
#define Usb_send_event(x)				(g_usb_event |= (1<<x))
#define Usb_ack_event(x)				(g_usb_event &= ~(1<<x))
#define Usb_clear_all_event()			(g_usb_event = 0)
#define Is_usb_event(x)					((g_usb_event & (1<<x)) ? TRUE : FALSE)
#define Is_not_usb_event(x)				((g_usb_event & (1<<x)) ? FALSE: TRUE)
#define Is_host_emergency_exit()		(Is_usb_event(EVT_HOST_DISCONNECTION) || Is_usb_event(EVT_USB_DEVICE_FUNCTION))
#define Is_usb_device()					(g_usb_mode==USB_MODE_DEVICE ? TRUE : FALSE)
#define Is_usb_host()					(g_usb_mode==USB_MODE_HOST   ? TRUE : FALSE)

#define EVT_USB_POWERED					1	// USBڑ
#define EVT_USB_UNPOWERED				2	// USBؒf
#define EVT_USB_DEVICE_FUNCTION			3	// USBu
#define EVT_USB_HOST_FUNCTION			4	// USBνē
#define EVT_USB_SUSPEND					5	// USBx~(Suspend)
#define EVT_USB_WAKE_UP					6	// USBNオ
#define EVT_USB_RESUME					7	// USBĊJ(Resume)
#define EVT_USB_RESET					8	// USBؾ
#define EVT_HOST_SOF					9	// HostڰъJno
#define EVT_HOST_HWUP					10	// HostNオ茟o
#define EVT_HOST_DISCONNECTION			11	// ڕWuؒf
	//! @}

	//! @defgroup std_req_values Wv`
	//! @{
#define GET_STATUS								0x00
#define GET_DEVICE								0x01
#define CLEAR_FEATURE							0x01	//!< ̋@\B
#define GET_STRING								0x03
#define SET_FEATURE								0x03	//!< ̋@\B
#define SET_ADDRESS								0x05
#define GET_DESCRIPTOR							0x06
#define SET_DESCRIPTOR							0x07
#define GET_CONFIGURATION						0x08
#define SET_CONFIGURATION						0x09
#define GET_INTERFACE							0x0A
#define SET_INTERFACE							0x0B
#define SYNCH_FRAME								0x0C

#define GET_DEVICE_DESCRIPTOR					1
#define GET_CONFIGURATION_DESCRIPTOR			4

#define REQUEST_DEVICE_STATUS					0x80
#define REQUEST_INTERFACE_STATUS				0x81
#define REQUEST_ENDPOINT_STATUS					0x82
#define ZERO_TYPE								0x00
#define INTERFACE_TYPE							0x01
#define ENDPOINT_TYPE							0x02

	// Lqq`
#define DEVICE_DESCRIPTOR						0x01
#define CONFIGURATION_DESCRIPTOR				0x02
#define STRING_DESCRIPTOR						0x03
#define INTERFACE_DESCRIPTOR					0x04
#define ENDPOINT_DESCRIPTOR						0x05
#define DEVICE_QUALIFIER_DESCRIPTOR				0x06
#define OTHER_SPEED_CONFIGURATION_DESCRIPTOR	0x07

	// W@\
#define FEATURE_DEVICE_REMOTE_WAKEUP			0x01
#define FEATURE_ENDPOINT_HALT					0x00

#define TEST_J									0x01
#define TEST_K									0x02
#define TEST_SEO_NAK							0x03
#define TEST_PACKET								0x04
#define TEST_FORCE_ENABLE						0x05

	// u
#define BUS_POWERED								0
#define SELF_POWERED							1

	//! @}

#define USB_MODE_UNDEFINED						0x00
#define USB_MODE_HOST							0x01
#define USB_MODE_DEVICE							0x02

//_____ 錾 _______________________________________________________________

extern volatile U16 g_usb_event;
extern U8 g_usb_mode;

/**
 * @brief ̊֐USB菇܂B
 *
 *  ̊֐USBUSB荞݂܂B
 *  _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
 *  x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑāA֐͑ΉUSB
 *  `ԏ֐Ăт܂B
 *
 *  @param	Ȃ
 *
 *  @return	Ȃ
 */
void usb_task_init (void);

/**
 *  @brief USBǗ̓_
 *
 *  xUSB`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSBǗ
 *  ֐Ăт܂B
 *
 *  @param	Ȃ
 *
 *  @return	Ȃ
*/
void usb_task (void);

extern volatile U8 private_sof_counter;

//! @}

#endif /* _USB_TASK_H_ */
